/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.19 from the
 * contents of RIPEMD160.xs. Do not edit this file, edit RIPEMD160.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "RIPEMD160.xs"
/*
Perl Extension for the RIPEMD160 Message-Digest Algorithm

This module by Christian H. Geuer <christian.geuer@crypto.gun.de>
following example of MD5 module and SHA module.

This extension (wrapper code and perl-stuff) may be distributed 
under the same terms as Perl. 
*/

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "wrap_160.h"

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 31 "RIPEMD160.c"

XS(XS_Crypt__RIPEMD160_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__RIPEMD160_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::RIPEMD160::new", "packname = \"Crypt::RIPEMD160\"");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	packname;
	Crypt__RIPEMD160	RETVAL;

	if (items < 1)
	    packname = "Crypt::RIPEMD160";
	else {
	    packname = (char *)SvPV_nolen(ST(0));
	}
#line 25 "RIPEMD160.xs"
	{
	    RETVAL = (Crypt__RIPEMD160) safemalloc(sizeof(RIPEMD160_INFO));
	    RIPEMD160_init(RETVAL);
	}
#line 58 "RIPEMD160.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::RIPEMD160", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__RIPEMD160_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__RIPEMD160_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::RIPEMD160::DESTROY", "ripemd160");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Crypt__RIPEMD160	ripemd160;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ripemd160 = INT2PTR(Crypt__RIPEMD160,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"Crypt::RIPEMD160::DESTROY",
			"ripemd160");
#line 37 "RIPEMD160.xs"
	{
	    safefree((char *) ripemd160);
	}
#line 92 "RIPEMD160.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__RIPEMD160_reset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__RIPEMD160_reset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::RIPEMD160::reset", "ripemd160");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Crypt__RIPEMD160	ripemd160;

	if (sv_derived_from(ST(0), "Crypt::RIPEMD160")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ripemd160 = INT2PTR(Crypt__RIPEMD160,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::RIPEMD160::reset",
			"ripemd160", "Crypt::RIPEMD160");
#line 46 "RIPEMD160.xs"
	{
	    RIPEMD160_init(ripemd160);
	}
#line 124 "RIPEMD160.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__RIPEMD160_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__RIPEMD160_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::RIPEMD160::add", "ripemd160, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Crypt__RIPEMD160	ripemd160;

	if (sv_derived_from(ST(0), "Crypt::RIPEMD160")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ripemd160 = INT2PTR(Crypt__RIPEMD160,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::RIPEMD160::add",
			"ripemd160", "Crypt::RIPEMD160");
#line 54 "RIPEMD160.xs"
	{
	    SV *svdata;
	    STRLEN len;
	    byte *strptr;
	    int i;

	    for (i = 1; i < items; i++) {
		strptr = (byte *) (SvPV(ST(i), len));
		RIPEMD160_update(ripemd160, strptr, len);
	    }
	}
#line 164 "RIPEMD160.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__RIPEMD160_digest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__RIPEMD160_digest)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Crypt::RIPEMD160::digest", "ripemd160");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Crypt__RIPEMD160	ripemd160;
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::RIPEMD160")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    ripemd160 = INT2PTR(Crypt__RIPEMD160,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Crypt::RIPEMD160::digest",
			"ripemd160", "Crypt::RIPEMD160");
#line 70 "RIPEMD160.xs"
	{
	    unsigned char d_str[20];

	    RIPEMD160_final(ripemd160);

	    d_str[ 0] = (unsigned char) ((ripemd160->MDbuf[0]      ) & 0xff);
	    d_str[ 1] = (unsigned char) ((ripemd160->MDbuf[0] >>  8) & 0xff);
	    d_str[ 2] = (unsigned char) ((ripemd160->MDbuf[0] >> 16) & 0xff);
	    d_str[ 3] = (unsigned char) ((ripemd160->MDbuf[0] >> 24) & 0xff);
	    d_str[ 4] = (unsigned char) ((ripemd160->MDbuf[1]      ) & 0xff);
	    d_str[ 5] = (unsigned char) ((ripemd160->MDbuf[1] >>  8) & 0xff);
	    d_str[ 6] = (unsigned char) ((ripemd160->MDbuf[1] >> 16) & 0xff);
	    d_str[ 7] = (unsigned char) ((ripemd160->MDbuf[1] >> 24) & 0xff);
	    d_str[ 8] = (unsigned char) ((ripemd160->MDbuf[2]      ) & 0xff);
	    d_str[ 9] = (unsigned char) ((ripemd160->MDbuf[2] >>  8) & 0xff);
	    d_str[10] = (unsigned char) ((ripemd160->MDbuf[2] >> 16) & 0xff);
	    d_str[11] = (unsigned char) ((ripemd160->MDbuf[2] >> 24) & 0xff);
	    d_str[12] = (unsigned char) ((ripemd160->MDbuf[3]      ) & 0xff);
	    d_str[13] = (unsigned char) ((ripemd160->MDbuf[3] >>  8) & 0xff);
	    d_str[14] = (unsigned char) ((ripemd160->MDbuf[3] >> 16) & 0xff);
	    d_str[15] = (unsigned char) ((ripemd160->MDbuf[3] >> 24) & 0xff);
	    d_str[16] = (unsigned char) ((ripemd160->MDbuf[4]      ) & 0xff);
	    d_str[17] = (unsigned char) ((ripemd160->MDbuf[4] >>  8) & 0xff);
	    d_str[18] = (unsigned char) ((ripemd160->MDbuf[4] >> 16) & 0xff);
	    d_str[19] = (unsigned char) ((ripemd160->MDbuf[4] >> 24) & 0xff);

	    ST(0) = sv_2mortal(newSVpv(d_str, 20));
	}
#line 222 "RIPEMD160.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Crypt__RIPEMD160); /* prototype to pass -Wmissing-prototypes */
XS(boot_Crypt__RIPEMD160)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("Crypt::RIPEMD160::new", XS_Crypt__RIPEMD160_new, file);
        newXS("Crypt::RIPEMD160::DESTROY", XS_Crypt__RIPEMD160_DESTROY, file);
        newXS("Crypt::RIPEMD160::reset", XS_Crypt__RIPEMD160_reset, file);
        newXS("Crypt::RIPEMD160::add", XS_Crypt__RIPEMD160_add, file);
        newXS("Crypt::RIPEMD160::digest", XS_Crypt__RIPEMD160_digest, file);
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

